import { Type as Side } from "./Side";
import { Type as OrderType } from "../common/OrderType";
import { Type as Timestamp } from "../google/protobuf/Timestamp";
export declare namespace $.api {
    interface Order {
        orderID: string;
        market: string;
        side: Side;
        types: OrderType[];
        price: number;
        remainingSize: number;
        createdAt?: Timestamp;
        clientOrderID: string;
        openOrderAccount: string;
    }
}
export declare type Type = $.api.Order;
export declare function getDefaultValue(): $.api.Order;
export declare function createValue(partialValue: Partial<$.api.Order>): $.api.Order;
export declare function encodeJson(value: $.api.Order): unknown;
export declare function decodeJson(value: any): $.api.Order;
export declare function encodeBinary(value: $.api.Order): Uint8Array;
export declare function decodeBinary(binary: Uint8Array): $.api.Order;
//# sourceMappingURL=Order.d.ts.map