import { Type as Side } from "./Side";
import { Type as OrderType } from "../common/OrderType";
import { Type as Project } from "./Project";
export declare namespace $.api {
    interface PostOrderRequest {
        ownerAddress: string;
        payerAddress: string;
        market: string;
        side: Side;
        type: OrderType[];
        amount: number;
        price: number;
        openOrdersAddress: string;
        clientOrderID: string;
        computeLimit: number;
        computePrice: string;
        tip?: string;
        project: Project;
    }
}
export declare type Type = $.api.PostOrderRequest;
export declare function getDefaultValue(): $.api.PostOrderRequest;
export declare function createValue(partialValue: Partial<$.api.PostOrderRequest>): $.api.PostOrderRequest;
export declare function encodeJson(value: $.api.PostOrderRequest): unknown;
export declare function decodeJson(value: any): $.api.PostOrderRequest;
export declare function encodeBinary(value: $.api.PostOrderRequest): Uint8Array;
export declare function decodeBinary(binary: Uint8Array): $.api.PostOrderRequest;
//# sourceMappingURL=PostOrderRequest.d.ts.map