import { RpcReturnType, RpcClientImpl } from "../../runtime/rpc";
import { Type as AccountsOfInterestRequest, encodeBinary, decodeBinary } from "../../messages/block_engine/AccountsOfInterestRequest";
import { Type as AccountsOfInterestUpdate, encodeBinary as encodeBinary_1, decodeBinary as decodeBinary_1 } from "../../messages/block_engine/AccountsOfInterestUpdate";
import { Type as ProgramsOfInterestRequest, encodeBinary as encodeBinary_2, decodeBinary as decodeBinary_2 } from "../../messages/block_engine/ProgramsOfInterestRequest";
import { Type as ProgramsOfInterestUpdate, encodeBinary as encodeBinary_3, decodeBinary as decodeBinary_3 } from "../../messages/block_engine/ProgramsOfInterestUpdate";
import { Type as PacketBatchUpdate, encodeBinary as encodeBinary_4, decodeBinary as decodeBinary_4 } from "../../messages/block_engine/PacketBatchUpdate";
import { Type as StartExpiringPacketStreamResponse, encodeBinary as encodeBinary_5, decodeBinary as decodeBinary_5 } from "../../messages/block_engine/StartExpiringPacketStreamResponse";
export interface Service<TReqArgs extends any[] = [], TResArgs extends any[] = []> {
    subscribeAccountsOfInterest(request: AccountsOfInterestRequest, ...args: TReqArgs): RpcReturnType<AsyncGenerator<AccountsOfInterestUpdate>, TResArgs>;
    subscribeProgramsOfInterest(request: ProgramsOfInterestRequest, ...args: TReqArgs): RpcReturnType<AsyncGenerator<ProgramsOfInterestUpdate>, TResArgs>;
    startExpiringPacketStream(request: AsyncGenerator<PacketBatchUpdate>, ...args: TReqArgs): RpcReturnType<AsyncGenerator<StartExpiringPacketStreamResponse>, TResArgs>;
}
export declare type MethodDescriptors = typeof methodDescriptors;
export declare const methodDescriptors: {
    readonly subscribeAccountsOfInterest: {
        readonly methodName: "SubscribeAccountsOfInterest";
        readonly service: {
            readonly serviceName: "block_engine.BlockEngineRelayer";
        };
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestType: {
            readonly serializeBinary: typeof encodeBinary;
            readonly deserializeBinary: typeof decodeBinary;
            readonly serializeJson: (value: AccountsOfInterestRequest) => string;
        };
        readonly responseType: {
            readonly serializeBinary: typeof encodeBinary_1;
            readonly deserializeBinary: typeof decodeBinary_1;
            readonly serializeJson: (value: AccountsOfInterestUpdate) => string;
        };
    };
    readonly subscribeProgramsOfInterest: {
        readonly methodName: "SubscribeProgramsOfInterest";
        readonly service: {
            readonly serviceName: "block_engine.BlockEngineRelayer";
        };
        readonly requestStream: false;
        readonly responseStream: true;
        readonly requestType: {
            readonly serializeBinary: typeof encodeBinary_2;
            readonly deserializeBinary: typeof decodeBinary_2;
            readonly serializeJson: (value: ProgramsOfInterestRequest) => string;
        };
        readonly responseType: {
            readonly serializeBinary: typeof encodeBinary_3;
            readonly deserializeBinary: typeof decodeBinary_3;
            readonly serializeJson: (value: ProgramsOfInterestUpdate) => string;
        };
    };
    readonly startExpiringPacketStream: {
        readonly methodName: "StartExpiringPacketStream";
        readonly service: {
            readonly serviceName: "block_engine.BlockEngineRelayer";
        };
        readonly requestStream: true;
        readonly responseStream: true;
        readonly requestType: {
            readonly serializeBinary: typeof encodeBinary_4;
            readonly deserializeBinary: typeof decodeBinary_4;
            readonly serializeJson: (value: PacketBatchUpdate) => string;
        };
        readonly responseType: {
            readonly serializeBinary: typeof encodeBinary_5;
            readonly deserializeBinary: typeof decodeBinary_5;
            readonly serializeJson: (value: StartExpiringPacketStreamResponse) => string;
        };
    };
};
export declare class RpcError<TTrailer = any> extends Error {
    trailer: TTrailer;
    constructor(trailer: TTrailer);
}
export interface CreateServiceClientConfig {
    responseOnly?: boolean;
    devtools?: true | {
        tags: string[];
    };
}
export declare function createServiceClient<TMetadata, THeader, TTrailer>(rpcClientImpl: RpcClientImpl<TMetadata, THeader, TTrailer>, config?: undefined): Service<[] | [TMetadata], []>;
export declare function createServiceClient<TMetadata, THeader, TTrailer>(rpcClientImpl: RpcClientImpl<TMetadata, THeader, TTrailer>, config: CreateServiceClientConfig & {
    responseOnly: false;
}): Service<[] | [TMetadata], [THeader, Promise<TTrailer>]>;
export declare function createServiceClient<TMetadata, THeader, TTrailer>(rpcClientImpl: RpcClientImpl<TMetadata, THeader, TTrailer>, config: CreateServiceClientConfig & {
    responseOnly?: true;
}): Service<[] | [TMetadata], []>;
//# sourceMappingURL=BlockEngineRelayer.d.ts.map