import { GetAccountBalanceRequest, GetAccountBalanceResponse, GetBlockStreamRequest, GetBlockStreamResponse, GetMarketsRequest, GetMarketsResponse, GetOpenOrdersRequest, GetOpenOrdersResponse, GetOrderbookRequest, GetOrderbookResponse, GetOrderbooksRequest, GetOrderbooksStreamResponse, GetOrderStatusStreamRequest, GetOrderStatusStreamResponse, GetPoolReservesStreamRequest, GetPoolReservesStreamResponse, GetPoolsRequest, GetPoolsResponse, GetPriceRequest, GetPriceResponse, GetPricesStreamRequest, GetPricesStreamResponse, GetQuotesRequest, GetQuotesResponse, GetQuotesStreamRequest, GetQuotesStreamResponse, GetRecentBlockHashRequest, GetRecentBlockHashResponse, GetServerTimeRequest, GetServerTimeResponse, GetSwapsStreamRequest, GetSwapsStreamResponse, GetTickersRequest, GetTickersResponse, GetTickersStreamResponse, GetTradesRequest, GetTradesResponse, GetTradesStreamResponse, GetUnsettledRequest, GetUnsettledResponse, PostCancelAllRequest, PostCancelAllResponse, PostCancelByClientOrderIDRequest, PostCancelOrderRequest, PostCancelOrderResponse, PostOrderRequest, PostOrderResponse, PostReplaceOrderRequest, PostSettleRequest, PostSettleResponse, PostSubmitBatchRequest, PostSubmitBatchResponse, PostSubmitRequest, PostSubmitResponse, RouteTradeSwapRequest, TradeSwapRequest, TradeSwapResponse, GetMarketDepthRequest, GetMarketDepthResponse, GetMarketDepthsRequest, GetMarketDepthsStreamResponse, GetMarketDepthRequestV2, GetMarketDepthResponseV2, GetMarketsRequestV2, GetMarketsResponseV2, GetOpenOrdersRequestV2, GetOrderbookRequestV2, GetOrderbookResponseV2, GetTickersRequestV2, GetTickersResponseV2, GetUnsettledRequestV2, PostCancelOrderRequestV2, PostCancelOrderResponseV2, PostOrderRequestV2, PostReplaceOrderRequestV2, PostSettleRequestV2, GetJupiterPricesRequest, GetJupiterPricesResponse, GetJupiterQuotesRequest, GetJupiterQuotesResponse, PostJupiterRouteSwapRequest, PostJupiterRouteSwapResponse, PostJupiterSwapRequest, PostJupiterSwapResponse, PostRaydiumRouteSwapRequest, PostRaydiumRouteSwapResponse, PostRaydiumSwapRequest, PostRaydiumSwapResponse, GetRaydiumPoolsRequest, GetRaydiumPoolsResponse, GetRaydiumPricesRequest, GetRaydiumPricesResponse, GetRaydiumQuotesRequest, GetRaydiumQuotesResponse, GetOpenOrdersResponseV2, GetNewRaydiumPoolsRequest, GetNewRaydiumPoolsResponse, GetTransactionResponse, GetTransactionRequest, GetRateLimitRequest, GetRateLimitResponse, GetPriorityFeeRequest, GetPriorityFeeResponse, PostJupiterSwapInstructionsRequest, PostJupiterSwapInstructionsResponse, GetTickersStreamRequest, GetRaydiumPoolReserveRequest, GetRaydiumPoolReserveResponse, GetBundleTipResponse, GetBundleTipRequest, GetPumpFunNewTokensStreamResponse, GetPumpFunNewTokensStreamRequest, GetPumpFunSwapsStreamRequest, GetPumpFunSwapsStreamResponse, PostPumpFunSwapRequest, PostPumpFunSwapResponse, GetPumpFunQuotesRequest, GetPumpFunQuotesResponse, GetPumpFunAMMSwapStreamRequest, GetPumpFunAMMSwapStreamResponse, GetRecentBlockHashRequestV2, GetRecentBlockHashResponseV2, PostRaydiumCPMMSwapRequest, PostRaydiumCPMMSwapResponse, GetRaydiumCPMMQuotesRequest, GetRaydiumCPMMQuotesResponse, GetRaydiumCLMMPoolsRequest, GetRaydiumCLMMPoolsResponse, GetRaydiumCLMMQuotesRequest, GetRaydiumCLMMQuotesResponse, GetNewRaydiumPoolsByTransactionResponse, GetNewRaydiumPoolsByTransactionRequest, GetPriorityFeeByProgramRequest, GetPriorityFeeByProgramResponse, PostPumpFunSwapRequestSol, PostSubmitSnipeRequest, PostSubmitSnipeResponse, PostSubmitPaladinRequest, GetLeaderScheduleRequest, GetLeaderScheduleResponse, GetPumpFunNewAmmPoolStreamRequest, GetPumpFunNewAmmPoolStreamResponse, GetTokenAccountsRequest, GetTokenAccountsResponse, PostRaydiumSwapInstructionsRequest, PostRaydiumSwapInstructionsResponse } from "../proto/messages/api";
import { BaseProvider } from "./base";
import { RpcReturnType } from "../proto/runtime/rpc";
export declare class WsProvider extends BaseProvider {
    private wsConnection;
    private address;
    private isClosed;
    private streamToCountMap;
    constructor(authHeader: string, privateKey?: string, address?: string);
    connect(): Promise<void>;
    close: () => void;
    getRateLimit(request: GetRateLimitRequest): RpcReturnType<Promise<GetRateLimitResponse>, []>;
    getTokenAccounts(request: GetTokenAccountsRequest): RpcReturnType<Promise<GetTokenAccountsResponse>, []>;
    getTransaction(request: GetTransactionRequest): RpcReturnType<Promise<GetTransactionResponse>, []>;
    getJupiterPrices(request: GetJupiterPricesRequest): RpcReturnType<Promise<GetJupiterPricesResponse>, []>;
    getJupiterQuotes(request: GetJupiterQuotesRequest): RpcReturnType<Promise<GetJupiterQuotesResponse>, []>;
    postJupiterRouteSwap(request: PostJupiterRouteSwapRequest): RpcReturnType<Promise<PostJupiterRouteSwapResponse>, []>;
    postJupiterSwap(request: PostJupiterSwapRequest): RpcReturnType<Promise<PostJupiterSwapResponse>, []>;
    postJupiterSwapInstructions(request: PostJupiterSwapInstructionsRequest): RpcReturnType<Promise<PostJupiterSwapInstructionsResponse>, []>;
    postRaydiumRouteSwap(request: PostRaydiumRouteSwapRequest): RpcReturnType<Promise<PostRaydiumRouteSwapResponse>, []>;
    postRaydiumCLMMRouteSwap(request: PostRaydiumRouteSwapRequest): RpcReturnType<Promise<PostRaydiumRouteSwapResponse>, []>;
    postRaydiumSwap(request: PostRaydiumSwapRequest): RpcReturnType<Promise<PostRaydiumSwapResponse>, []>;
    postRaydiumSwapInstructions(request: PostRaydiumSwapInstructionsRequest): RpcReturnType<Promise<PostRaydiumSwapInstructionsResponse>, []>;
    postRaydiumCPMMSwap(request: PostRaydiumCPMMSwapRequest): RpcReturnType<Promise<PostRaydiumCPMMSwapResponse>, []>;
    postRaydiumCLMMSwap(request: PostRaydiumSwapRequest): RpcReturnType<Promise<PostRaydiumSwapResponse>, []>;
    getRaydiumPoolReserve(request: GetRaydiumPoolReserveRequest): RpcReturnType<Promise<GetRaydiumPoolReserveResponse>, []>;
    getRaydiumPools(request: GetRaydiumPoolsRequest): RpcReturnType<Promise<GetRaydiumPoolsResponse>, []>;
    getRaydiumCLMMPools(request: GetRaydiumCLMMPoolsRequest): RpcReturnType<Promise<GetRaydiumCLMMPoolsResponse>, []>;
    getRaydiumPrices(request: GetRaydiumPricesRequest): RpcReturnType<Promise<GetRaydiumPricesResponse>, []>;
    getRaydiumQuotes(request: GetRaydiumQuotesRequest): RpcReturnType<Promise<GetRaydiumQuotesResponse>, []>;
    getRaydiumCLMMQuotes(request: GetRaydiumCLMMQuotesRequest): RpcReturnType<Promise<GetRaydiumCLMMQuotesResponse>, []>;
    getRaydiumCPMMQuotes(request: GetRaydiumCPMMQuotesRequest): RpcReturnType<Promise<GetRaydiumCPMMQuotesResponse>, []>;
    getPumpFunQuotes(request: GetPumpFunQuotesRequest): RpcReturnType<Promise<GetPumpFunQuotesResponse>, []>;
    getOrderbookV2(request: GetOrderbookRequestV2): Promise<GetOrderbookResponseV2>;
    getMarketDepthV2(request: GetMarketDepthRequestV2): Promise<GetMarketDepthResponseV2>;
    getMarketsV2(request: GetMarketsRequestV2): Promise<GetMarketsResponseV2>;
    getTickersV2(request: GetTickersRequestV2): Promise<GetTickersResponseV2>;
    getOpenOrdersV2(request: GetOpenOrdersRequestV2): Promise<GetOpenOrdersResponseV2>;
    getUnsettledV2(request: GetUnsettledRequestV2): Promise<GetUnsettledResponse>;
    postOrderV2(request: PostOrderRequestV2): Promise<PostOrderResponse>;
    postCancelOrderV2(request: PostCancelOrderRequestV2): Promise<PostCancelOrderResponseV2>;
    postSettleV2(request: PostSettleRequestV2): Promise<PostSettleResponse>;
    postReplaceOrderV2(request: PostReplaceOrderRequestV2): Promise<PostOrderResponse>;
    getOrderbook(request: GetOrderbookRequest): Promise<GetOrderbookResponse>;
    getMarketDepth(request: GetMarketDepthRequest): Promise<GetMarketDepthResponse>;
    getMarkets(request: GetMarketsRequest): Promise<GetMarketsResponse>;
    getTickers(request: GetTickersRequest): Promise<GetTickersResponse>;
    getTrades(request: GetTradesRequest): Promise<GetTradesResponse>;
    getServerTime(request: GetServerTimeRequest): Promise<GetServerTimeResponse>;
    getOpenOrders(request: GetOpenOrdersRequest): Promise<GetOpenOrdersResponse>;
    getUnsettled(request: GetUnsettledRequest): Promise<GetUnsettledResponse>;
    getAccountBalance(request: GetAccountBalanceRequest): Promise<GetAccountBalanceResponse>;
    getAccountBalanceV2(request: GetAccountBalanceRequest): Promise<GetAccountBalanceResponse>;
    getOrderbooksStream: (request: GetOrderbooksRequest) => Promise<AsyncGenerator<GetOrderbooksStreamResponse>>;
    getPumpFunNewTokensStream: (request: GetPumpFunNewTokensStreamRequest) => Promise<AsyncGenerator<GetPumpFunNewTokensStreamResponse>>;
    getPumpFunNewAmmPoolStream: (request: GetPumpFunNewAmmPoolStreamRequest) => Promise<AsyncGenerator<GetPumpFunNewAmmPoolStreamResponse>>;
    getPumpFunSwapsStream: (request: GetPumpFunSwapsStreamRequest) => Promise<AsyncGenerator<GetPumpFunSwapsStreamResponse>>;
    getPumpFunAMMSwapStream: (request: GetPumpFunAMMSwapStreamRequest) => Promise<AsyncGenerator<GetPumpFunAMMSwapStreamResponse>>;
    getMarketDepthsStream: (request: GetMarketDepthsRequest) => Promise<AsyncGenerator<GetMarketDepthsStreamResponse>>;
    getSwapsStream: (request: GetSwapsStreamRequest) => Promise<AsyncGenerator<GetSwapsStreamResponse>>;
    getTickersStream: (request: GetTickersStreamRequest) => Promise<AsyncGenerator<GetTickersStreamResponse>>;
    getTradesStream: (request: GetTradesRequest) => Promise<AsyncGenerator<GetTradesStreamResponse>>;
    getOrderStatusStream: (request: GetOrderStatusStreamRequest) => Promise<AsyncGenerator<GetOrderStatusStreamResponse>>;
    getRecentBlockHashStream: (request: GetRecentBlockHashRequest) => Promise<AsyncGenerator<GetRecentBlockHashResponse>>;
    getPricesStream: (request: GetPricesStreamRequest) => Promise<AsyncGenerator<GetPricesStreamResponse>>;
    getQuotesStream: (request: GetQuotesStreamRequest) => Promise<AsyncGenerator<GetQuotesStreamResponse>>;
    getPoolReservesStream: (request: GetPoolReservesStreamRequest) => Promise<AsyncGenerator<GetPoolReservesStreamResponse>>;
    getBlockStream: (request: GetBlockStreamRequest) => Promise<AsyncGenerator<GetBlockStreamResponse>>;
    getNewRaydiumPoolsStream: (request: GetNewRaydiumPoolsRequest) => Promise<AsyncGenerator<GetNewRaydiumPoolsResponse>>;
    getNewRaydiumPoolsByTransactionStream: (request: GetNewRaydiumPoolsByTransactionRequest) => Promise<AsyncGenerator<GetNewRaydiumPoolsByTransactionResponse>>;
    getPriorityFeeStream: (request: GetPriorityFeeRequest) => Promise<AsyncGenerator<GetPriorityFeeResponse>>;
    getPriorityFeeByProgramStream: (request: GetPriorityFeeByProgramRequest) => Promise<AsyncGenerator<GetPriorityFeeByProgramResponse>>;
    getBundleTipStream: (request: GetBundleTipRequest) => Promise<AsyncGenerator<GetBundleTipResponse>>;
    postOrder(request: PostOrderRequest): Promise<PostOrderResponse>;
    postSubmit(request: PostSubmitRequest): Promise<PostSubmitResponse>;
    postSubmitBatch(request: PostSubmitBatchRequest): Promise<PostSubmitBatchResponse>;
    postSubmitV2(request: PostSubmitRequest): Promise<PostSubmitResponse>;
    postSubmitSnipeV2(request: PostSubmitSnipeRequest): Promise<PostSubmitSnipeResponse>;
    postSubmitPaladinV2(request: PostSubmitPaladinRequest): Promise<PostSubmitResponse>;
    postSubmitBatchV2(request: PostSubmitBatchRequest): Promise<PostSubmitBatchResponse>;
    postCancelOrder(request: PostCancelOrderRequest): Promise<PostCancelOrderResponse>;
    postCancelByClientOrderID(request: PostCancelByClientOrderIDRequest): Promise<PostCancelOrderResponse>;
    postCancelAll(request: PostCancelAllRequest): Promise<PostCancelAllResponse>;
    postSettle(request: PostSettleRequest): Promise<PostSettleResponse>;
    postReplaceByClientOrderID(request: PostOrderRequest): Promise<PostOrderResponse>;
    postReplaceOrder(request: PostReplaceOrderRequest): Promise<PostOrderResponse>;
    postTradeSwap(request: TradeSwapRequest): Promise<TradeSwapResponse>;
    postPumpFunSwap(request: PostPumpFunSwapRequest): Promise<PostPumpFunSwapResponse>;
    postPumpFunSwapSol(request: PostPumpFunSwapRequestSol): Promise<PostPumpFunSwapResponse>;
    getPools(request: GetPoolsRequest): Promise<GetPoolsResponse>;
    getQuotes(request: GetQuotesRequest): Promise<GetQuotesResponse>;
    postRouteTradeSwap(request: RouteTradeSwapRequest): Promise<TradeSwapResponse>;
    getPrice(request: GetPriceRequest): Promise<GetPriceResponse>;
    getRecentBlockHash(request: GetRecentBlockHashRequest): Promise<GetRecentBlockHashResponse>;
    getRecentBlockHashV2(request: GetRecentBlockHashRequestV2): Promise<GetRecentBlockHashResponseV2>;
    getPriorityFee(request: GetPriorityFeeRequest): Promise<GetPriorityFeeResponse>;
    getPriorityFeeByProgram(request: GetPriorityFeeByProgramRequest): Promise<GetPriorityFeeByProgramResponse>;
    getLeaderSchedule(request: GetLeaderScheduleRequest): Promise<GetLeaderScheduleResponse>;
    cancelGetOrderbooksStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetSwapsStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetTickersStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetTradesStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetOrderStatusStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetRecentBlockhashStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetNewRaydiumPoolsStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetQuotesStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetPoolReservesStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetPriorityFeeStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetBundleTipStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelGetPumpFunAMMSwapStreamByCount: (streamNumber: number) => Promise<boolean>;
    cancelAllGetOrderbooksStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetSwapsStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetTickersStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetTradesStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetOrderStatusStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetNewRaydiumPoolsStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetRecentBlockhashStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetQuotesStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetPoolReservesStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetPriorityFeeStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetBundleTipStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetPumpFunNewAmmPoolStream: () => Promise<Awaited<boolean>[]>;
    cancelAllGetPumpFunAMMSwapStream: () => Promise<Awaited<boolean>[]>;
    private manageGetStreamMaps;
    private cancelStreamByCount;
    private cancelAllStreams;
}
//# sourceMappingURL=ws.d.ts.map