import { AsyncBlockingQueue } from "../utils/blockingqueue";
export declare class RpcWsConnection {
    private socket?;
    private readonly address;
    private readonly authHeader;
    private pingInterval?;
    private readonly PING_INTERVAL;
    private requestId;
    private requestMap;
    private subscriptionMap;
    queue: AsyncBlockingQueue<any>;
    constructor(address: string, authHeader: string);
    connect(): Promise<void>;
    close(): void;
    call<T, R>(methodName: string, methodParams: T): Promise<R>;
    _formWSRequest<T>(methodName: string, methodParams: T): {
        id: number;
        req: string;
    };
    subscribe<T>(streamName: string, streamParams: T): Promise<string>;
    unsubscribe(subscriptionId: string): Promise<boolean>;
    subscribeToNotifications<T>(subscriptionID: string): AsyncGenerator<T>;
    sendPing(): void;
}
//# sourceMappingURL=rpcclient.d.ts.map